/* FileStore.c generated by valac 0.54.8, the Vala compiler
 * generated from FileStore.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*-
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: Michael Terry
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "deja.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_FILE_STORE (file_store_get_type ())
#define FILE_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_STORE, FileStore))
#define FILE_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILE_STORE, FileStoreClass))
#define IS_FILE_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_STORE))
#define IS_FILE_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILE_STORE))
#define FILE_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILE_STORE, FileStoreClass))

typedef struct _FileStore FileStore;
typedef struct _FileStoreClass FileStoreClass;
typedef struct _FileStorePrivate FileStorePrivate;
enum  {
	FILE_STORE_0_PROPERTY,
	FILE_STORE_TREE_PROPERTY,
	FILE_STORE_CAN_GO_UP_PROPERTY,
	FILE_STORE_SEARCH_FILTER_PROPERTY,
	FILE_STORE_NUM_PROPERTIES
};
static GParamSpec* file_store_properties[FILE_STORE_NUM_PROPERTIES];
typedef enum  {
	FILE_STORE_COLUMN_FILENAME = 0,
	FILE_STORE_COLUMN_SORT_KEY,
	FILE_STORE_COLUMN_ICON,
	FILE_STORE_COLUMN_GICON,
	FILE_STORE_COLUMN_PATH,
	FILE_STORE_COLUMN_NODE
} FileStoreColumn;

#define FILE_STORE_TYPE_COLUMN (file_store_column_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block8Data Block8Data;

struct _FileStore {
	GtkListStore parent_instance;
	FileStorePrivate * priv;
};

struct _FileStoreClass {
	GtkListStoreClass parent_class;
};

struct _FileStorePrivate {
	DejaDupFileTree* _tree;
	gboolean _can_go_up;
	gchar* _search_filter;
	DejaDupFileTreeNode* current;
};

struct _Block8Data {
	int _ref_count_;
	FileStore* self;
	gchar** needle_tokens;
	gint needle_tokens_length1;
};

static gint FileStore_private_offset;
static gpointer file_store_parent_class = NULL;

VALA_EXTERN GType file_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FileStore, g_object_unref)
VALA_EXTERN GType file_store_column_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void file_store_register_operation (FileStore* self,
                                    DejaDupOperationFiles* op);
static void file_store_set_tree (FileStore* self,
                          DejaDupFileTree* value);
static void file_store_handle_listed_files (FileStore* self,
                                     DejaDupOperationFiles* op,
                                     DejaDupFileTree* tree);
static void _file_store_handle_listed_files_deja_dup_operation_files_listed_current_files (DejaDupOperationFiles* _sender,
                                                                                    DejaDupFileTree* tree,
                                                                                    gpointer self);
VALA_EXTERN gboolean file_store_go_down (FileStore* self,
                             GtkTreePath* path);
static void file_store_set_current (FileStore* self,
                             DejaDupFileTreeNode* node);
VALA_EXTERN void file_store_go_up (FileStore* self);
VALA_EXTERN gboolean file_store_get_can_go_up (FileStore* self);
VALA_EXTERN GFile* file_store_get_file (FileStore* self,
                            GtkTreePath* path);
static gchar* file_store_get_full_path_from_path (FileStore* self,
                                           GtkTreePath* path);
VALA_EXTERN DejaDupFileTree* file_store_get_tree (FileStore* self);
static void file_store_update_search (FileStore* self);
VALA_EXTERN const gchar* file_store_get_search_filter (FileStore* self);
static void file_store_recursive_search (FileStore* self,
                                  gchar** needle_tokens,
                                  gint needle_tokens_length1,
                                  DejaDupFileTreeNode* node);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda26_ (Block8Data* _data8_,
                  const gchar* name,
                  DejaDupFileTreeNode* child);
static gchar** _vala_array_dup2 (gchar** self,
                          gssize length);
static void file_store_insert_file (FileStore* self,
                             DejaDupFileTreeNode* node);
static void ___lambda26__gh_func (gconstpointer key,
                           gconstpointer value,
                           gpointer self);
static void file_store_set_can_go_up (FileStore* self,
                               gboolean value);
static void __lambda25_ (FileStore* self,
                  const gchar* name,
                  DejaDupFileTreeNode* child);
static void ___lambda25__gh_func (gconstpointer key,
                           gconstpointer value,
                           gpointer self);
static gchar* file_store_collate_key (FileStore* self,
                               DejaDupFileTreeNode* node);
VALA_EXTERN FileStore* file_store_new (void);
VALA_EXTERN FileStore* file_store_construct (GType object_type);
VALA_EXTERN void file_store_set_search_filter (FileStore* self,
                                   const gchar* value);
static GObject * file_store_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
static gint _file_store___lambda27_ (FileStore* self,
                              GtkTreeModel* m,
                              GtkTreeIter* a,
                              GtkTreeIter* b);
static gint __file_store___lambda27__gtk_tree_iter_compare_func (GtkTreeModel* model,
                                                          GtkTreeIter* a,
                                                          GtkTreeIter* b,
                                                          gpointer self);
static void _file_store_update_search_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self);
static void file_store_finalize (GObject * obj);
static GType file_store_get_type_once (void);
static void _vala_file_store_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_file_store_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
file_store_get_instance_private (FileStore* self)
{
	return G_STRUCT_MEMBER_P (self, FileStore_private_offset);
}

 G_GNUC_NO_INLINE static GType
file_store_column_get_type_once (void)
{
	static const GEnumValue values[] = {{FILE_STORE_COLUMN_FILENAME, "FILE_STORE_COLUMN_FILENAME", "filename"}, {FILE_STORE_COLUMN_SORT_KEY, "FILE_STORE_COLUMN_SORT_KEY", "sort-key"}, {FILE_STORE_COLUMN_ICON, "FILE_STORE_COLUMN_ICON", "icon"}, {FILE_STORE_COLUMN_GICON, "FILE_STORE_COLUMN_GICON", "gicon"}, {FILE_STORE_COLUMN_PATH, "FILE_STORE_COLUMN_PATH", "path"}, {FILE_STORE_COLUMN_NODE, "FILE_STORE_COLUMN_NODE", "node"}, {0, NULL, NULL}};
	GType file_store_column_type_id;
	file_store_column_type_id = g_enum_register_static ("FileStoreColumn", values);
	return file_store_column_type_id;
}

GType
file_store_column_get_type (void)
{
	static volatile gsize file_store_column_type_id__volatile = 0;
	if (g_once_init_enter (&file_store_column_type_id__volatile)) {
		GType file_store_column_type_id;
		file_store_column_type_id = file_store_column_get_type_once ();
		g_once_init_leave (&file_store_column_type_id__volatile, file_store_column_type_id);
	}
	return file_store_column_type_id__volatile;
}

static void
_file_store_handle_listed_files_deja_dup_operation_files_listed_current_files (DejaDupOperationFiles* _sender,
                                                                               DejaDupFileTree* tree,
                                                                               gpointer self)
{
	file_store_handle_listed_files ((FileStore*) self, _sender, tree);
}

void
file_store_register_operation (FileStore* self,
                               DejaDupOperationFiles* op)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (op != NULL);
	_g_object_unref0 (self->priv->current);
	self->priv->current = NULL;
	file_store_set_tree (self, NULL);
	gtk_list_store_clear ((GtkListStore*) self);
	g_signal_connect_object (op, "listed-current-files", (GCallback) _file_store_handle_listed_files_deja_dup_operation_files_listed_current_files, self, 0);
}

gboolean
file_store_go_down (FileStore* self,
                    GtkTreePath* path)
{
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
	DejaDupFileTreeNode* child = NULL;
	GtkTreeIter _tmp2_;
	DejaDupFileTreeNode* _tmp3_ = NULL;
	DejaDupFileTreeNode* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	DejaDupFileTreeNode* _tmp7_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	_tmp1_ = gtk_tree_model_get_iter ((GtkTreeModel*) self, &_tmp0_, path);
	iter = _tmp0_;
	if (!_tmp1_) {
		result = FALSE;
		return result;
	}
	_tmp2_ = iter;
	gtk_tree_model_get ((GtkTreeModel*) self, &_tmp2_, FILE_STORE_COLUMN_NODE, &_tmp3_, -1);
	_g_object_unref0 (child);
	child = _tmp3_;
	_tmp4_ = child;
	_tmp5_ = deja_dup_file_tree_node_get_kind (_tmp4_);
	_tmp6_ = _tmp5_;
	if (g_strcmp0 (_tmp6_, "dir") != 0) {
		result = FALSE;
		_g_object_unref0 (child);
		return result;
	}
	_tmp7_ = child;
	file_store_set_current (self, _tmp7_);
	result = TRUE;
	_g_object_unref0 (child);
	return result;
}

void
file_store_go_up (FileStore* self)
{
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_can_go_up;
	if (_tmp0_) {
		DejaDupFileTreeNode* _tmp1_;
		DejaDupFileTreeNode* _tmp2_;
		DejaDupFileTreeNode* _tmp3_;
		_tmp1_ = self->priv->current;
		_tmp2_ = deja_dup_file_tree_node_get_parent (_tmp1_);
		_tmp3_ = _tmp2_;
		file_store_set_current (self, _tmp3_);
	}
}

GFile*
file_store_get_file (FileStore* self,
                     GtkTreePath* path)
{
	gchar* filepath = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = file_store_get_full_path_from_path (self, path);
	filepath = _tmp0_;
	_tmp1_ = filepath;
	if (_tmp1_ == NULL) {
		result = NULL;
		_g_free0 (filepath);
		return result;
	}
	_tmp2_ = filepath;
	_tmp3_ = g_strconcat ("/", _tmp2_, NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_file_new_for_path (_tmp4_);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	result = _tmp6_;
	_g_free0 (filepath);
	return result;
}

static gchar*
file_store_get_full_path_from_path (FileStore* self,
                                    GtkTreePath* path)
{
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
	gchar* filename = NULL;
	gchar* rel_path = NULL;
	GtkTreeIter _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp1_ = gtk_tree_model_get_iter ((GtkTreeModel*) self, &_tmp0_, path);
	iter = _tmp0_;
	if (!_tmp1_) {
		result = NULL;
		return result;
	}
	_tmp2_ = iter;
	gtk_tree_model_get ((GtkTreeModel*) self, &_tmp2_, FILE_STORE_COLUMN_FILENAME, &_tmp3_, FILE_STORE_COLUMN_PATH, &_tmp4_, -1);
	_g_free0 (filename);
	filename = _tmp3_;
	_g_free0 (rel_path);
	rel_path = _tmp4_;
	_tmp5_ = rel_path;
	if (_tmp5_ == NULL) {
		DejaDupFileTree* _tmp6_;
		DejaDupFileTreeNode* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		_tmp6_ = self->priv->_tree;
		_tmp7_ = self->priv->current;
		_tmp8_ = deja_dup_file_tree_node_to_path (_tmp6_, _tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = filename;
		_tmp11_ = g_build_filename (_tmp9_, _tmp10_, NULL);
		_tmp12_ = _tmp11_;
		_g_free0 (_tmp9_);
		result = _tmp12_;
		_g_free0 (rel_path);
		_g_free0 (filename);
		return result;
	} else {
		DejaDupFileTree* _tmp13_;
		DejaDupFileTreeNode* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		_tmp13_ = self->priv->_tree;
		_tmp14_ = self->priv->current;
		_tmp15_ = deja_dup_file_tree_node_to_path (_tmp13_, _tmp14_);
		_tmp16_ = _tmp15_;
		_tmp17_ = rel_path;
		_tmp18_ = filename;
		_tmp19_ = g_build_filename (_tmp16_, _tmp17_, _tmp18_, NULL);
		_tmp20_ = _tmp19_;
		_g_free0 (_tmp16_);
		result = _tmp20_;
		_g_free0 (rel_path);
		_g_free0 (filename);
		return result;
	}
}

static void
file_store_update_search (FileStore* self)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gchar** needle_tokens = NULL;
	const gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint needle_tokens_length1;
	gint _needle_tokens_size_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	DejaDupFileTreeNode* _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->_search_filter;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp2_;
		_tmp2_ = self->priv->_search_filter;
		_tmp0_ = g_strcmp0 (_tmp2_, "") == 0;
	}
	if (_tmp0_) {
		DejaDupFileTreeNode* _tmp3_;
		_tmp3_ = self->priv->current;
		file_store_set_current (self, _tmp3_);
		return;
	}
	_tmp4_ = self->priv->_search_filter;
	_tmp6_ = _tmp5_ = g_str_tokenize_and_fold (_tmp4_, "", NULL);
	needle_tokens = _tmp6_;
	needle_tokens_length1 = _vala_array_length (_tmp5_);
	_needle_tokens_size_ = needle_tokens_length1;
	gtk_list_store_clear ((GtkListStore*) self);
	_tmp7_ = needle_tokens;
	_tmp7__length1 = needle_tokens_length1;
	_tmp8_ = self->priv->current;
	file_store_recursive_search (self, _tmp7_, (gint) _tmp7__length1, _tmp8_);
	needle_tokens = (_vala_array_free (needle_tokens, needle_tokens_length1, (GDestroyNotify) g_free), NULL);
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
	g_atomic_int_inc (&_data8_->_ref_count_);
	return _data8_;
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
		FileStore* self;
		self = _data8_->self;
		_g_object_unref0 (self);
		g_slice_free (Block8Data, _data8_);
	}
}

static gchar**
_vala_array_dup2 (gchar** self,
                  gssize length)
{
	if (length >= 0) {
		gchar** result;
		gssize i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static void
__lambda26_ (Block8Data* _data8_,
             const gchar* name,
             DejaDupFileTreeNode* child)
{
	FileStore* self;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gboolean all_matched = FALSE;
	self = _data8_->self;
	g_return_if_fail (name != NULL);
	g_return_if_fail (child != NULL);
	_tmp0_ = child->search_tokens;
	_tmp0__length1 = child->search_tokens_length1;
	if (_tmp0_ == NULL) {
		gchar** unicode_tokens = NULL;
		gint unicode_tokens_length1 = 0;
		gint _unicode_tokens_size_ = 0;
		gchar** ascii_tokens = NULL;
		gint ascii_tokens_length1 = 0;
		gint _ascii_tokens_size_ = 0;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar** _tmp3_ = NULL;
		gchar** _tmp4_;
		gchar** _tmp5_;
		gchar** all_tokens = NULL;
		gchar** _tmp6_;
		gint _tmp6__length1;
		gchar** _tmp7_;
		gint _tmp7__length1;
		gchar** _tmp8_;
		gint all_tokens_length1;
		gint _all_tokens_size_;
		gchar** _tmp24_;
		gint _tmp24__length1;
		gchar** _tmp25_;
		gint _tmp25__length1;
		_tmp1_ = deja_dup_file_tree_node_get_filename (child);
		_tmp2_ = _tmp1_;
		_tmp5_ = _tmp4_ = g_str_tokenize_and_fold (_tmp2_, "", &_tmp3_);
		ascii_tokens = (_vala_array_free (ascii_tokens, ascii_tokens_length1, (GDestroyNotify) g_free), NULL);
		ascii_tokens = _tmp3_;
		ascii_tokens_length1 = -1;
		_ascii_tokens_size_ = ascii_tokens_length1;
		ascii_tokens_length1 = _vala_array_length (ascii_tokens);
		unicode_tokens = (_vala_array_free (unicode_tokens, unicode_tokens_length1, (GDestroyNotify) g_free), NULL);
		unicode_tokens = _tmp5_;
		unicode_tokens_length1 = _vala_array_length (_tmp4_);
		_unicode_tokens_size_ = unicode_tokens_length1;
		_tmp6_ = unicode_tokens;
		_tmp6__length1 = unicode_tokens_length1;
		_tmp7_ = ascii_tokens;
		_tmp7__length1 = ascii_tokens_length1;
		_tmp8_ = g_new0 (gchar*, (_tmp6__length1 + _tmp7__length1) + 1);
		all_tokens = _tmp8_;
		all_tokens_length1 = _tmp6__length1 + _tmp7__length1;
		_all_tokens_size_ = all_tokens_length1;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp9_ = FALSE;
				_tmp9_ = TRUE;
				while (TRUE) {
					gchar** _tmp11_;
					gint _tmp11__length1;
					gchar** _tmp12_;
					gint _tmp12__length1;
					gchar** _tmp13_;
					gint _tmp13__length1;
					const gchar* _tmp14_;
					gchar* _tmp15_;
					if (!_tmp9_) {
						gint _tmp10_;
						_tmp10_ = i;
						i = _tmp10_ + 1;
					}
					_tmp9_ = FALSE;
					_tmp11_ = unicode_tokens;
					_tmp11__length1 = unicode_tokens_length1;
					if (!(i < _tmp11__length1)) {
						break;
					}
					_tmp12_ = all_tokens;
					_tmp12__length1 = all_tokens_length1;
					_tmp13_ = unicode_tokens;
					_tmp13__length1 = unicode_tokens_length1;
					_tmp14_ = _tmp13_[i];
					_tmp15_ = g_strdup (_tmp14_);
					_g_free0 (_tmp12_[i]);
					_tmp12_[i] = _tmp15_;
				}
			}
		}
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp16_ = FALSE;
				_tmp16_ = TRUE;
				while (TRUE) {
					gchar** _tmp18_;
					gint _tmp18__length1;
					gchar** _tmp19_;
					gint _tmp19__length1;
					gchar** _tmp20_;
					gint _tmp20__length1;
					gchar** _tmp21_;
					gint _tmp21__length1;
					const gchar* _tmp22_;
					gchar* _tmp23_;
					if (!_tmp16_) {
						gint _tmp17_;
						_tmp17_ = i;
						i = _tmp17_ + 1;
					}
					_tmp16_ = FALSE;
					_tmp18_ = ascii_tokens;
					_tmp18__length1 = ascii_tokens_length1;
					if (!(i < _tmp18__length1)) {
						break;
					}
					_tmp19_ = all_tokens;
					_tmp19__length1 = all_tokens_length1;
					_tmp20_ = unicode_tokens;
					_tmp20__length1 = unicode_tokens_length1;
					_tmp21_ = ascii_tokens;
					_tmp21__length1 = ascii_tokens_length1;
					_tmp22_ = _tmp21_[i];
					_tmp23_ = g_strdup (_tmp22_);
					_g_free0 (_tmp19_[_tmp20__length1 + i]);
					_tmp19_[_tmp20__length1 + i] = _tmp23_;
				}
			}
		}
		_tmp24_ = all_tokens;
		_tmp24__length1 = all_tokens_length1;
		_tmp25_ = (_tmp24_ != NULL) ? _vala_array_dup2 (_tmp24_, _tmp24__length1) : _tmp24_;
		_tmp25__length1 = _tmp24__length1;
		child->search_tokens = (_vala_array_free (child->search_tokens, child->search_tokens_length1, (GDestroyNotify) g_free), NULL);
		child->search_tokens = _tmp25_;
		child->search_tokens_length1 = _tmp25__length1;
		all_tokens = (_vala_array_free (all_tokens, all_tokens_length1, (GDestroyNotify) g_free), NULL);
		ascii_tokens = (_vala_array_free (ascii_tokens, ascii_tokens_length1, (GDestroyNotify) g_free), NULL);
		unicode_tokens = (_vala_array_free (unicode_tokens, unicode_tokens_length1, (GDestroyNotify) g_free), NULL);
	}
	all_matched = TRUE;
	{
		gchar** needle_collection = NULL;
		gint needle_collection_length1 = 0;
		gint _needle_collection_size_ = 0;
		gint needle_it = 0;
		needle_collection = _data8_->needle_tokens;
		needle_collection_length1 = _data8_->needle_tokens_length1;
		for (needle_it = 0; needle_it < needle_collection_length1; needle_it = needle_it + 1) {
			gchar* _tmp26_;
			gchar* needle = NULL;
			_tmp26_ = g_strdup (needle_collection[needle_it]);
			needle = _tmp26_;
			{
				gboolean needle_matched = FALSE;
				gchar** _tmp27_;
				gint _tmp27__length1;
				needle_matched = FALSE;
				_tmp27_ = child->search_tokens;
				_tmp27__length1 = child->search_tokens_length1;
				{
					gchar** token_collection = NULL;
					gint token_collection_length1 = 0;
					gint _token_collection_size_ = 0;
					gint token_it = 0;
					token_collection = _tmp27_;
					token_collection_length1 = _tmp27__length1;
					for (token_it = 0; token_it < token_collection_length1; token_it = token_it + 1) {
						gchar* _tmp28_;
						gchar* token = NULL;
						_tmp28_ = g_strdup (token_collection[token_it]);
						token = _tmp28_;
						{
							const gchar* _tmp29_;
							const gchar* _tmp30_;
							_tmp29_ = token;
							_tmp30_ = needle;
							if (string_contains (_tmp29_, _tmp30_)) {
								needle_matched = TRUE;
								_g_free0 (token);
								break;
							}
							_g_free0 (token);
						}
					}
				}
				if (!needle_matched) {
					all_matched = FALSE;
					_g_free0 (needle);
					break;
				}
				_g_free0 (needle);
			}
		}
	}
	if (all_matched) {
		file_store_insert_file (self, child);
	}
	file_store_recursive_search (self, _data8_->needle_tokens, (gint) _data8_->needle_tokens_length1, child);
}

static void
___lambda26__gh_func (gconstpointer key,
                      gconstpointer value,
                      gpointer self)
{
	__lambda26_ (self, (const gchar*) key, (DejaDupFileTreeNode*) value);
}

static void
file_store_recursive_search (FileStore* self,
                             gchar** needle_tokens,
                             gint needle_tokens_length1,
                             DejaDupFileTreeNode* node)
{
	Block8Data* _data8_;
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (node != NULL);
	_data8_ = g_slice_new0 (Block8Data);
	_data8_->_ref_count_ = 1;
	_data8_->self = g_object_ref (self);
	_data8_->needle_tokens = needle_tokens;
	_data8_->needle_tokens_length1 = needle_tokens_length1;
	_tmp0_ = deja_dup_file_tree_node_get_children (node);
	_tmp1_ = _tmp0_;
	g_hash_table_foreach (_tmp1_, ___lambda26__gh_func, _data8_);
	block8_data_unref (_data8_);
	_data8_ = NULL;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda25_ (FileStore* self,
             const gchar* name,
             DejaDupFileTreeNode* child)
{
	g_return_if_fail (name != NULL);
	g_return_if_fail (child != NULL);
	file_store_insert_file (self, child);
}

static void
___lambda25__gh_func (gconstpointer key,
                      gconstpointer value,
                      gpointer self)
{
	__lambda25_ ((FileStore*) self, (const gchar*) key, (DejaDupFileTreeNode*) value);
}

static void
file_store_set_current (FileStore* self,
                        DejaDupFileTreeNode* node)
{
	DejaDupFileTreeNode* _tmp0_;
	DejaDupFileTreeNode* _tmp1_;
	DejaDupFileTree* _tmp2_;
	DejaDupFileTreeNode* _tmp3_;
	DejaDupFileTreeNode* _tmp4_;
	DejaDupFileTreeNode* _tmp5_;
	GHashTable* _tmp6_;
	GHashTable* _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (node != NULL);
	gtk_list_store_clear ((GtkListStore*) self);
	_tmp0_ = _g_object_ref0 (node);
	_g_object_unref0 (self->priv->current);
	self->priv->current = _tmp0_;
	_tmp1_ = self->priv->current;
	_tmp2_ = self->priv->_tree;
	_tmp3_ = deja_dup_file_tree_get_root (_tmp2_);
	_tmp4_ = _tmp3_;
	file_store_set_can_go_up (self, _tmp1_ != _tmp4_);
	_tmp5_ = self->priv->current;
	_tmp6_ = deja_dup_file_tree_node_get_children (_tmp5_);
	_tmp7_ = _tmp6_;
	g_hash_table_foreach (_tmp7_, ___lambda25__gh_func, self);
}

static gchar*
file_store_collate_key (FileStore* self,
                        DejaDupFileTreeNode* node)
{
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* prefix = NULL;
	gchar* _tmp3_;
	gchar* key = NULL;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (node != NULL, NULL);
	_tmp1_ = deja_dup_file_tree_node_get_kind (node);
	_tmp2_ = _tmp1_;
	if (g_strcmp0 (_tmp2_, "dir") == 0) {
		_tmp0_ = "0:";
	} else {
		_tmp0_ = "1:";
	}
	_tmp3_ = g_strdup (_tmp0_);
	prefix = _tmp3_;
	_tmp4_ = deja_dup_file_tree_node_get_filename (node);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_utf8_collate_key_for_filename (_tmp5_, (gssize) -1);
	key = _tmp6_;
	_tmp7_ = g_strconcat (prefix, key, NULL);
	result = _tmp7_;
	_g_free0 (key);
	_g_free0 (prefix);
	return result;
}

static void
file_store_insert_file (FileStore* self,
                        DejaDupFileTreeNode* node)
{
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* content_type = NULL;
	gchar* _tmp7_;
	GIcon* gicon = NULL;
	const gchar* _tmp8_;
	GIcon* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	DejaDupFileTreeNode* iter = NULL;
	DejaDupFileTreeNode* _tmp19_;
	gchar* path = NULL;
	const gchar* _tmp42_;
	const gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	GIcon* _tmp46_;
	const gchar* _tmp47_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (node != NULL);
	_tmp1_ = deja_dup_file_tree_node_get_kind (node);
	_tmp2_ = _tmp1_;
	if (g_strcmp0 (_tmp2_, "dir") == 0) {
		gchar* _tmp3_;
		_tmp3_ = g_content_type_from_mime_type ("inode/directory");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp3_;
	} else {
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp4_ = deja_dup_file_tree_node_get_filename (node);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_content_type_guess (_tmp5_, NULL, (gsize) 0, NULL);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp6_;
	}
	_tmp7_ = g_strdup (_tmp0_);
	content_type = _tmp7_;
	_tmp8_ = content_type;
	_tmp9_ = g_content_type_get_icon (_tmp8_);
	gicon = _tmp9_;
	_tmp10_ = deja_dup_file_tree_node_get_kind (node);
	_tmp11_ = _tmp10_;
	if (g_strcmp0 (_tmp11_, "sym") == 0) {
		GEmblem* emblem = NULL;
		GThemedIcon* _tmp12_;
		GThemedIcon* _tmp13_;
		GEmblem* _tmp14_;
		GEmblem* _tmp15_;
		GIcon* _tmp16_;
		GEmblem* _tmp17_;
		GEmblemedIcon* _tmp18_;
		_tmp12_ = (GThemedIcon*) g_themed_icon_new ("emblem-symbolic-link");
		_tmp13_ = _tmp12_;
		_tmp14_ = g_emblem_new ((GIcon*) _tmp13_);
		_tmp15_ = _tmp14_;
		_g_object_unref0 (_tmp13_);
		emblem = _tmp15_;
		_tmp16_ = gicon;
		_tmp17_ = emblem;
		_tmp18_ = (GEmblemedIcon*) g_emblemed_icon_new (_tmp16_, _tmp17_);
		_g_object_unref0 (gicon);
		gicon = (GIcon*) _tmp18_;
		_g_object_unref0 (emblem);
	}
	_tmp19_ = _g_object_ref0 (node);
	iter = _tmp19_;
	path = NULL;
	while (TRUE) {
		DejaDupFileTreeNode* _tmp20_;
		DejaDupFileTreeNode* _tmp21_;
		DejaDupFileTreeNode* _tmp22_;
		DejaDupFileTreeNode* _tmp23_;
		const gchar* _tmp24_;
		DejaDupFileTreeNode* _tmp38_;
		DejaDupFileTreeNode* _tmp39_;
		DejaDupFileTreeNode* _tmp40_;
		DejaDupFileTreeNode* _tmp41_;
		_tmp20_ = iter;
		_tmp21_ = deja_dup_file_tree_node_get_parent (_tmp20_);
		_tmp22_ = _tmp21_;
		_tmp23_ = self->priv->current;
		if (!(_tmp22_ != _tmp23_)) {
			break;
		}
		_tmp24_ = path;
		if (_tmp24_ == NULL) {
			DejaDupFileTreeNode* _tmp25_;
			DejaDupFileTreeNode* _tmp26_;
			DejaDupFileTreeNode* _tmp27_;
			const gchar* _tmp28_;
			const gchar* _tmp29_;
			gchar* _tmp30_;
			_tmp25_ = iter;
			_tmp26_ = deja_dup_file_tree_node_get_parent (_tmp25_);
			_tmp27_ = _tmp26_;
			_tmp28_ = deja_dup_file_tree_node_get_filename (_tmp27_);
			_tmp29_ = _tmp28_;
			_tmp30_ = g_strdup (_tmp29_);
			_g_free0 (path);
			path = _tmp30_;
		} else {
			DejaDupFileTreeNode* _tmp31_;
			DejaDupFileTreeNode* _tmp32_;
			DejaDupFileTreeNode* _tmp33_;
			const gchar* _tmp34_;
			const gchar* _tmp35_;
			const gchar* _tmp36_;
			gchar* _tmp37_;
			_tmp31_ = iter;
			_tmp32_ = deja_dup_file_tree_node_get_parent (_tmp31_);
			_tmp33_ = _tmp32_;
			_tmp34_ = deja_dup_file_tree_node_get_filename (_tmp33_);
			_tmp35_ = _tmp34_;
			_tmp36_ = path;
			_tmp37_ = g_build_filename (_tmp35_, _tmp36_, NULL);
			_g_free0 (path);
			path = _tmp37_;
		}
		_tmp38_ = iter;
		_tmp39_ = deja_dup_file_tree_node_get_parent (_tmp38_);
		_tmp40_ = _tmp39_;
		_tmp41_ = _g_object_ref0 (_tmp40_);
		_g_object_unref0 (iter);
		iter = _tmp41_;
	}
	_tmp42_ = deja_dup_file_tree_node_get_filename (node);
	_tmp43_ = _tmp42_;
	_tmp44_ = file_store_collate_key (self, node);
	_tmp45_ = _tmp44_;
	_tmp46_ = gicon;
	_tmp47_ = path;
	gtk_list_store_insert_with_values ((GtkListStore*) self, NULL, -1, FILE_STORE_COLUMN_FILENAME, _tmp43_, FILE_STORE_COLUMN_SORT_KEY, _tmp45_, FILE_STORE_COLUMN_GICON, _tmp46_, FILE_STORE_COLUMN_PATH, _tmp47_, FILE_STORE_COLUMN_NODE, node, -1);
	_g_free0 (_tmp45_);
	_g_free0 (path);
	_g_object_unref0 (iter);
	_g_object_unref0 (gicon);
	_g_free0 (content_type);
	_g_free0 (_tmp0_);
}

static void
file_store_handle_listed_files (FileStore* self,
                                DejaDupOperationFiles* op,
                                DejaDupFileTree* tree)
{
	DejaDupFileTreeNode* _tmp0_;
	DejaDupFileTreeNode* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (op != NULL);
	g_return_if_fail (tree != NULL);
	file_store_set_tree (self, tree);
	_tmp0_ = deja_dup_file_tree_get_root (tree);
	_tmp1_ = _tmp0_;
	file_store_set_current (self, _tmp1_);
}

FileStore*
file_store_construct (GType object_type)
{
	FileStore * self = NULL;
	self = (FileStore*) g_object_new (object_type, NULL);
	return self;
}

FileStore*
file_store_new (void)
{
	return file_store_construct (TYPE_FILE_STORE);
}

DejaDupFileTree*
file_store_get_tree (FileStore* self)
{
	DejaDupFileTree* result;
	DejaDupFileTree* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_tree;
	result = _tmp0_;
	return result;
}

static void
file_store_set_tree (FileStore* self,
                     DejaDupFileTree* value)
{
	DejaDupFileTree* old_value;
	g_return_if_fail (self != NULL);
	old_value = file_store_get_tree (self);
	if (old_value != value) {
		DejaDupFileTree* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_tree);
		self->priv->_tree = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, file_store_properties[FILE_STORE_TREE_PROPERTY]);
	}
}

gboolean
file_store_get_can_go_up (FileStore* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_can_go_up;
	return result;
}

static void
file_store_set_can_go_up (FileStore* self,
                          gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = file_store_get_can_go_up (self);
	if (old_value != value) {
		self->priv->_can_go_up = value;
		g_object_notify_by_pspec ((GObject *) self, file_store_properties[FILE_STORE_CAN_GO_UP_PROPERTY]);
	}
}

const gchar*
file_store_get_search_filter (FileStore* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_search_filter;
	result = _tmp0_;
	return result;
}

void
file_store_set_search_filter (FileStore* self,
                              const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = file_store_get_search_filter (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_search_filter);
		self->priv->_search_filter = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, file_store_properties[FILE_STORE_SEARCH_FILTER_PROPERTY]);
	}
}

static gint
_file_store___lambda27_ (FileStore* self,
                         GtkTreeModel* m,
                         GtkTreeIter* a,
                         GtkTreeIter* b)
{
	gchar* akey = NULL;
	gchar* bkey = NULL;
	GtkTreeIter _tmp0_;
	gchar* _tmp1_ = NULL;
	GtkTreeIter _tmp2_;
	gchar* _tmp3_ = NULL;
	GCompareFunc _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gint result = 0;
	g_return_val_if_fail (m != NULL, 0);
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	_tmp0_ = *a;
	gtk_tree_model_get ((GtkTreeModel*) self, &_tmp0_, FILE_STORE_COLUMN_SORT_KEY, &_tmp1_, -1);
	_g_free0 (akey);
	akey = _tmp1_;
	_tmp2_ = *b;
	gtk_tree_model_get ((GtkTreeModel*) self, &_tmp2_, FILE_STORE_COLUMN_SORT_KEY, &_tmp3_, -1);
	_g_free0 (bkey);
	bkey = _tmp3_;
	_tmp4_ = ((GCompareFunc) g_strcmp0);
	_tmp5_ = akey;
	_tmp6_ = bkey;
	result = _tmp4_ (_tmp5_, _tmp6_);
	_g_free0 (bkey);
	_g_free0 (akey);
	return result;
}

static gint
__file_store___lambda27__gtk_tree_iter_compare_func (GtkTreeModel* model,
                                                     GtkTreeIter* a,
                                                     GtkTreeIter* b,
                                                     gpointer self)
{
	gint result;
	result = _file_store___lambda27_ ((FileStore*) self, model, a, b);
	return result;
}

static void
_file_store_update_search_g_object_notify (GObject* _sender,
                                           GParamSpec* pspec,
                                           gpointer self)
{
	file_store_update_search ((FileStore*) self);
}

static GObject *
file_store_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FileStore * self;
	GType* _tmp0_;
	GType* _tmp1_;
	gint _tmp1__length1;
	parent_class = G_OBJECT_CLASS (file_store_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FILE_STORE, FileStore);
	_tmp0_ = g_new0 (GType, 6);
	_tmp0_[0] = G_TYPE_STRING;
	_tmp0_[1] = G_TYPE_STRING;
	_tmp0_[2] = gdk_pixbuf_get_type ();
	_tmp0_[3] = g_icon_get_type ();
	_tmp0_[4] = G_TYPE_STRING;
	_tmp0_[5] = DEJA_DUP_FILE_TREE_TYPE_NODE;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = 6;
	gtk_list_store_set_column_types ((GtkListStore*) self, (gint) 6, _tmp1_);
	_tmp1_ = (g_free (_tmp1_), NULL);
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) self, (gint) FILE_STORE_COLUMN_FILENAME, GTK_SORT_ASCENDING);
	gtk_tree_sortable_set_sort_func ((GtkTreeSortable*) self, (gint) FILE_STORE_COLUMN_FILENAME, __file_store___lambda27__gtk_tree_iter_compare_func, g_object_ref (self), g_object_unref);
	g_signal_connect_object ((GObject*) self, "notify::search-filter", (GCallback) _file_store_update_search_g_object_notify, self, 0);
	return obj;
}

static void
file_store_class_init (FileStoreClass * klass,
                       gpointer klass_data)
{
	file_store_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &FileStore_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_file_store_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_file_store_set_property;
	G_OBJECT_CLASS (klass)->constructor = file_store_constructor;
	G_OBJECT_CLASS (klass)->finalize = file_store_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILE_STORE_TREE_PROPERTY, file_store_properties[FILE_STORE_TREE_PROPERTY] = g_param_spec_object ("tree", "tree", "tree", DEJA_DUP_TYPE_FILE_TREE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILE_STORE_CAN_GO_UP_PROPERTY, file_store_properties[FILE_STORE_CAN_GO_UP_PROPERTY] = g_param_spec_boolean ("can-go-up", "can-go-up", "can-go-up", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILE_STORE_SEARCH_FILTER_PROPERTY, file_store_properties[FILE_STORE_SEARCH_FILTER_PROPERTY] = g_param_spec_string ("search-filter", "search-filter", "search-filter", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
file_store_instance_init (FileStore * self,
                          gpointer klass)
{
	self->priv = file_store_get_instance_private (self);
	self->priv->_tree = NULL;
	self->priv->_can_go_up = FALSE;
	self->priv->_search_filter = NULL;
}

static void
file_store_finalize (GObject * obj)
{
	FileStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FILE_STORE, FileStore);
	_g_object_unref0 (self->priv->_tree);
	_g_free0 (self->priv->_search_filter);
	_g_object_unref0 (self->priv->current);
	G_OBJECT_CLASS (file_store_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
file_store_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FileStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) file_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FileStore), 0, (GInstanceInitFunc) file_store_instance_init, NULL };
	GType file_store_type_id;
	file_store_type_id = g_type_register_static (gtk_list_store_get_type (), "FileStore", &g_define_type_info, 0);
	FileStore_private_offset = g_type_add_instance_private (file_store_type_id, sizeof (FileStorePrivate));
	return file_store_type_id;
}

GType
file_store_get_type (void)
{
	static volatile gsize file_store_type_id__volatile = 0;
	if (g_once_init_enter (&file_store_type_id__volatile)) {
		GType file_store_type_id;
		file_store_type_id = file_store_get_type_once ();
		g_once_init_leave (&file_store_type_id__volatile, file_store_type_id);
	}
	return file_store_type_id__volatile;
}

static void
_vala_file_store_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	FileStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FILE_STORE, FileStore);
	switch (property_id) {
		case FILE_STORE_TREE_PROPERTY:
		g_value_set_object (value, file_store_get_tree (self));
		break;
		case FILE_STORE_CAN_GO_UP_PROPERTY:
		g_value_set_boolean (value, file_store_get_can_go_up (self));
		break;
		case FILE_STORE_SEARCH_FILTER_PROPERTY:
		g_value_set_string (value, file_store_get_search_filter (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_file_store_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	FileStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FILE_STORE, FileStore);
	switch (property_id) {
		case FILE_STORE_TREE_PROPERTY:
		file_store_set_tree (self, g_value_get_object (value));
		break;
		case FILE_STORE_CAN_GO_UP_PROPERTY:
		file_store_set_can_go_up (self, g_value_get_boolean (value));
		break;
		case FILE_STORE_SEARCH_FILTER_PROPERTY:
		file_store_set_search_filter (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

