/* WidgetUtils.c generated by valac 0.54.8, the Vala compiler
 * generated from WidgetUtils.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*-
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: Canonical Ltd
 * SPDX-FileCopyrightText: Michael Terry
 */

#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include "deja.h"
#include <gio/gio.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block11Data Block11Data;

struct _Block11Data {
	int _ref_count_;
	GtkWidget* w;
};

VALA_EXTERN void deja_dup_run_error_dialog (GtkWindow* parent,
                                const gchar* header,
                                const gchar* message);
VALA_EXTERN void deja_dup_destroy_widget (GtkWidget* w);
VALA_EXTERN void deja_dup_show_uri (GtkWindow* parent,
                        const gchar* link);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static gboolean __lambda4_ (Block11Data* _data11_);
static gboolean ___lambda4__gsource_func (gpointer self);
VALA_EXTERN gboolean deja_dup_start_monitor_if_needed (DejaDupFilteredSettings* settings);
VALA_EXTERN void deja_dup_gui_initialize (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

void
deja_dup_run_error_dialog (GtkWindow* parent,
                           const gchar* header,
                           const gchar* message)
{
	GtkMessageDialog* dlg = NULL;
	GtkMessageDialog* _tmp0_;
	g_return_if_fail (header != NULL);
	g_return_if_fail (message != NULL);
	_tmp0_ = (GtkMessageDialog*) gtk_message_dialog_new (parent, GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, "%s", header);
	g_object_ref_sink (_tmp0_);
	dlg = _tmp0_;
	gtk_message_dialog_format_secondary_text (dlg, "%s", message);
	gtk_dialog_run ((GtkDialog*) dlg);
	deja_dup_destroy_widget ((GtkWidget*) dlg);
	_g_object_unref0 (dlg);
}

void
deja_dup_show_uri (GtkWindow* parent,
                   const gchar* link)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (link != NULL);
	{
		gtk_show_uri_on_window (parent, link, gtk_get_current_event_time (), &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp0_ = g_strdup_printf (_ ("Could not display %s"), link);
		_tmp1_ = _tmp0_;
		_tmp2_ = e;
		_tmp3_ = _tmp2_->message;
		deja_dup_run_error_dialog (parent, _tmp1_, _tmp3_);
		_g_free0 (_tmp1_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
	g_atomic_int_inc (&_data11_->_ref_count_);
	return _data11_;
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
		_g_object_unref0 (_data11_->w);
		g_slice_free (Block11Data, _data11_);
	}
}

static gboolean
__lambda4_ (Block11Data* _data11_)
{
	gboolean result = FALSE;
	gtk_widget_destroy (_data11_->w);
	result = FALSE;
	return result;
}

static gboolean
___lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda4_ (self);
	return result;
}

void
deja_dup_destroy_widget (GtkWidget* w)
{
	Block11Data* _data11_;
	GtkWidget* _tmp0_;
	g_return_if_fail (w != NULL);
	_data11_ = g_slice_new0 (Block11Data);
	_data11_->_ref_count_ = 1;
	_tmp0_ = _g_object_ref0 (w);
	_g_object_unref0 (_data11_->w);
	_data11_->w = _tmp0_;
	gtk_widget_hide (_data11_->w);
	g_object_ref ((GObject*) _data11_->w);
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda4__gsource_func, block11_data_ref (_data11_), block11_data_unref);
	block11_data_unref (_data11_);
	_data11_ = NULL;
}

gboolean
deja_dup_start_monitor_if_needed (DejaDupFilteredSettings* settings)
{
	gboolean result = FALSE;
	g_return_val_if_fail (settings != NULL, FALSE);
	if (g_settings_get_boolean ((GSettings*) settings, DEJA_DUP_PERIODIC_KEY)) {
		gchar** _tmp0_;
		gchar** _tmp1_;
		gint _tmp1__length1;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp0_ = g_new0 (gchar*, 0 + 1);
		_tmp1_ = _tmp0_;
		_tmp1__length1 = 0;
		_tmp2_ = deja_dup_get_monitor_exec ();
		_tmp3_ = _tmp2_;
		deja_dup_run_deja_dup (_tmp1_, (gint) 0, _tmp3_);
		_g_free0 (_tmp3_);
		_tmp1_ = (_vala_array_free (_tmp1_, _tmp1__length1, (GDestroyNotify) g_free), NULL);
	}
	result = G_SOURCE_CONTINUE;
	return result;
}

void
deja_dup_gui_initialize (void)
{
	DejaDupFilteredSettings* settings = NULL;
	DejaDupFilteredSettings* _tmp0_;
	deja_dup_initialize ();
	_tmp0_ = deja_dup_get_settings (NULL);
	settings = _tmp0_;
	g_signal_connect (settings, "changed::" DEJA_DUP_PERIODIC_KEY, (GCallback) deja_dup_start_monitor_if_needed, NULL);
	deja_dup_start_monitor_if_needed (settings);
	g_object_ref ((GObject*) settings);
	_g_object_unref0 (settings);
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

