/* RecursiveMove.c generated by valac 0.54.8, the Vala compiler
 * generated from RecursiveMove.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*-
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: Michael Terry
 */

#include "deja.h"
#include <gio/gio.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

enum  {
	DEJA_DUP_RECURSIVE_MOVE_0_PROPERTY,
	DEJA_DUP_RECURSIVE_MOVE_NUM_PROPERTIES
};
static GParamSpec* deja_dup_recursive_move_properties[DEJA_DUP_RECURSIVE_MOVE_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

static gpointer deja_dup_recursive_move_parent_class = NULL;

static void deja_dup_recursive_move_progress_callback (DejaDupRecursiveMove* self,
                                                gint64 current_num_bytes,
                                                gint64 total_num_bytes);
static void deja_dup_recursive_move_real_handle_file (DejaDupRecursiveOp* base);
static void _deja_dup_recursive_move_progress_callback_gfile_progress_callback (gint64 current_num_bytes,
                                                                         gint64 total_num_bytes,
                                                                         gpointer self);
static void deja_dup_recursive_move_real_handle_dir (DejaDupRecursiveOp* base);
static void deja_dup_recursive_move_real_finish_dir (DejaDupRecursiveOp* base);
static DejaDupRecursiveOp* deja_dup_recursive_move_real_clone_for_info (DejaDupRecursiveOp* base,
                                                                 GFileInfo* info);
static GType deja_dup_recursive_move_get_type_once (void);

DejaDupRecursiveMove*
deja_dup_recursive_move_construct (GType object_type,
                                   GFile* source,
                                   GFile* dest)
{
	DejaDupRecursiveMove * self = NULL;
	g_return_val_if_fail (source != NULL, NULL);
	g_return_val_if_fail (dest != NULL, NULL);
	self = (DejaDupRecursiveMove*) g_object_new (object_type, "src", source, "dst", dest, NULL);
	return self;
}

DejaDupRecursiveMove*
deja_dup_recursive_move_new (GFile* source,
                             GFile* dest)
{
	return deja_dup_recursive_move_construct (DEJA_DUP_TYPE_RECURSIVE_MOVE, source, dest);
}

static void
deja_dup_recursive_move_progress_callback (DejaDupRecursiveMove* self,
                                           gint64 current_num_bytes,
                                           gint64 total_num_bytes)
{
	g_return_if_fail (self != NULL);
}

static void
_deja_dup_recursive_move_progress_callback_gfile_progress_callback (gint64 current_num_bytes,
                                                                    gint64 total_num_bytes,
                                                                    gpointer self)
{
	deja_dup_recursive_move_progress_callback ((DejaDupRecursiveMove*) self, current_num_bytes, total_num_bytes);
}

static void
deja_dup_recursive_move_real_handle_file (DejaDupRecursiveOp* base)
{
	DejaDupRecursiveMove * self;
	GError* _inner_error0_ = NULL;
	self = (DejaDupRecursiveMove*) base;
	if (((DejaDupRecursiveOp*) self)->dst_type == G_FILE_TYPE_DIRECTORY) {
		{
			GFile* _tmp0_;
			GFile* _tmp1_;
			_tmp0_ = deja_dup_recursive_op_get_dst ((DejaDupRecursiveOp*) self);
			_tmp1_ = _tmp0_;
			g_file_delete (_tmp1_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GFile* _tmp2_;
			GFile* _tmp3_;
			GFile* _tmp4_;
			GFile* _tmp5_;
			GError* _tmp6_;
			const gchar* _tmp7_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp2_ = deja_dup_recursive_op_get_src ((DejaDupRecursiveOp*) self);
			_tmp3_ = _tmp2_;
			_tmp4_ = deja_dup_recursive_op_get_dst ((DejaDupRecursiveOp*) self);
			_tmp5_ = _tmp4_;
			_tmp6_ = e;
			_tmp7_ = _tmp6_->message;
			g_signal_emit_by_name ((DejaDupRecursiveOp*) self, "raise-error", _tmp3_, _tmp5_, _tmp7_);
			_g_error_free0 (e);
			return;
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	{
		GFile* _tmp8_;
		GFile* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		_tmp8_ = deja_dup_recursive_op_get_src ((DejaDupRecursiveOp*) self);
		_tmp9_ = _tmp8_;
		_tmp10_ = deja_dup_recursive_op_get_dst ((DejaDupRecursiveOp*) self);
		_tmp11_ = _tmp10_;
		g_file_move (_tmp9_, _tmp11_, (G_FILE_COPY_ALL_METADATA | G_FILE_COPY_NOFOLLOW_SYMLINKS) | G_FILE_COPY_OVERWRITE, NULL, _deja_dup_recursive_move_progress_callback_gfile_progress_callback, self, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (g_error_matches (_inner_error0_, G_IO_ERROR, G_IO_ERROR_PERMISSION_DENIED)) {
				goto __catch1_g_io_error_permission_denied;
			}
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_io_error_permission_denied:
	{
		g_clear_error (&_inner_error0_);
		{
			GFile* _tmp12_;
			GFile* _tmp13_;
			GFile* _tmp14_;
			GFile* _tmp15_;
			_tmp12_ = deja_dup_recursive_op_get_src ((DejaDupRecursiveOp*) self);
			_tmp13_ = _tmp12_;
			_tmp14_ = deja_dup_recursive_op_get_dst ((DejaDupRecursiveOp*) self);
			_tmp15_ = _tmp14_;
			g_file_copy (_tmp13_, _tmp15_, (G_FILE_COPY_ALL_METADATA | G_FILE_COPY_NOFOLLOW_SYMLINKS) | G_FILE_COPY_OVERWRITE, NULL, _deja_dup_recursive_move_progress_callback_gfile_progress_callback, self, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch2_g_error;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			GFile* _tmp16_;
			GFile* _tmp17_;
			GFile* _tmp18_;
			GFile* _tmp19_;
			GError* _tmp20_;
			const gchar* _tmp21_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp16_ = deja_dup_recursive_op_get_src ((DejaDupRecursiveOp*) self);
			_tmp17_ = _tmp16_;
			_tmp18_ = deja_dup_recursive_op_get_dst ((DejaDupRecursiveOp*) self);
			_tmp19_ = _tmp18_;
			_tmp20_ = e;
			_tmp21_ = _tmp20_->message;
			g_signal_emit_by_name ((DejaDupRecursiveOp*) self, "raise-error", _tmp17_, _tmp19_, _tmp21_);
			_g_error_free0 (e);
		}
		__finally2:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GFile* _tmp22_;
		GFile* _tmp23_;
		GFile* _tmp24_;
		GFile* _tmp25_;
		GError* _tmp26_;
		const gchar* _tmp27_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp22_ = deja_dup_recursive_op_get_src ((DejaDupRecursiveOp*) self);
		_tmp23_ = _tmp22_;
		_tmp24_ = deja_dup_recursive_op_get_dst ((DejaDupRecursiveOp*) self);
		_tmp25_ = _tmp24_;
		_tmp26_ = e;
		_tmp27_ = _tmp26_->message;
		g_signal_emit_by_name ((DejaDupRecursiveOp*) self, "raise-error", _tmp23_, _tmp25_, _tmp27_);
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
deja_dup_recursive_move_real_handle_dir (DejaDupRecursiveOp* base)
{
	DejaDupRecursiveMove * self;
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
	self = (DejaDupRecursiveMove*) base;
	if (((DejaDupRecursiveOp*) self)->dst_type != G_FILE_TYPE_UNKNOWN) {
		_tmp0_ = ((DejaDupRecursiveOp*) self)->dst_type != G_FILE_TYPE_DIRECTORY;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		{
			GFile* _tmp1_;
			GFile* _tmp2_;
			_tmp1_ = deja_dup_recursive_op_get_dst ((DejaDupRecursiveOp*) self);
			_tmp2_ = _tmp1_;
			g_file_delete (_tmp2_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GFile* _tmp3_;
			GFile* _tmp4_;
			GFile* _tmp5_;
			GFile* _tmp6_;
			GError* _tmp7_;
			const gchar* _tmp8_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp3_ = deja_dup_recursive_op_get_src ((DejaDupRecursiveOp*) self);
			_tmp4_ = _tmp3_;
			_tmp5_ = deja_dup_recursive_op_get_dst ((DejaDupRecursiveOp*) self);
			_tmp6_ = _tmp5_;
			_tmp7_ = e;
			_tmp8_ = _tmp7_->message;
			g_signal_emit_by_name ((DejaDupRecursiveOp*) self, "raise-error", _tmp4_, _tmp6_, _tmp8_);
			_g_error_free0 (e);
			return;
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		((DejaDupRecursiveOp*) self)->dst_type = G_FILE_TYPE_UNKNOWN;
	}
	if (((DejaDupRecursiveOp*) self)->dst_type == G_FILE_TYPE_UNKNOWN) {
		{
			GFile* _tmp9_;
			GFile* _tmp10_;
			_tmp9_ = deja_dup_recursive_op_get_dst ((DejaDupRecursiveOp*) self);
			_tmp10_ = _tmp9_;
			g_file_make_directory (_tmp10_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GFile* _tmp11_;
			GFile* _tmp12_;
			GFile* _tmp13_;
			GFile* _tmp14_;
			GError* _tmp15_;
			const gchar* _tmp16_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp11_ = deja_dup_recursive_op_get_src ((DejaDupRecursiveOp*) self);
			_tmp12_ = _tmp11_;
			_tmp13_ = deja_dup_recursive_op_get_dst ((DejaDupRecursiveOp*) self);
			_tmp14_ = _tmp13_;
			_tmp15_ = e;
			_tmp16_ = _tmp15_->message;
			g_signal_emit_by_name ((DejaDupRecursiveOp*) self, "raise-error", _tmp12_, _tmp14_, _tmp16_);
			_g_error_free0 (e);
			return;
		}
		__finally1:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

static void
deja_dup_recursive_move_real_finish_dir (DejaDupRecursiveOp* base)
{
	DejaDupRecursiveMove * self;
	GError* _inner_error0_ = NULL;
	self = (DejaDupRecursiveMove*) base;
	{
		GFile* _tmp0_;
		GFile* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		_tmp0_ = deja_dup_recursive_op_get_src ((DejaDupRecursiveOp*) self);
		_tmp1_ = _tmp0_;
		_tmp2_ = deja_dup_recursive_op_get_dst ((DejaDupRecursiveOp*) self);
		_tmp3_ = _tmp2_;
		g_file_copy_attributes (_tmp1_, _tmp3_, G_FILE_COPY_NOFOLLOW_SYMLINKS | G_FILE_COPY_ALL_METADATA, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	{
		GFile* _tmp4_;
		GFile* _tmp5_;
		_tmp4_ = deja_dup_recursive_op_get_src ((DejaDupRecursiveOp*) self);
		_tmp5_ = _tmp4_;
		g_file_delete (_tmp5_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		g_clear_error (&_inner_error0_);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static DejaDupRecursiveOp*
deja_dup_recursive_move_real_clone_for_info (DejaDupRecursiveOp* base,
                                             GFileInfo* info)
{
	DejaDupRecursiveMove * self;
	gchar* child_name = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* src_child = NULL;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* dst_child = NULL;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	DejaDupRecursiveMove* _tmp8_;
	DejaDupRecursiveOp* result = NULL;
	self = (DejaDupRecursiveMove*) base;
	g_return_val_if_fail (info != NULL, NULL);
	_tmp0_ = g_file_info_get_name (info);
	_tmp1_ = g_strdup (_tmp0_);
	child_name = _tmp1_;
	_tmp2_ = deja_dup_recursive_op_get_src ((DejaDupRecursiveOp*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_file_get_child (_tmp3_, child_name);
	src_child = _tmp4_;
	_tmp5_ = deja_dup_recursive_op_get_dst ((DejaDupRecursiveOp*) self);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_file_get_child (_tmp6_, child_name);
	dst_child = _tmp7_;
	_tmp8_ = deja_dup_recursive_move_new (src_child, dst_child);
	result = (DejaDupRecursiveOp*) _tmp8_;
	_g_object_unref0 (dst_child);
	_g_object_unref0 (src_child);
	_g_free0 (child_name);
	return result;
}

static void
deja_dup_recursive_move_class_init (DejaDupRecursiveMoveClass * klass,
                                    gpointer klass_data)
{
	deja_dup_recursive_move_parent_class = g_type_class_peek_parent (klass);
	((DejaDupRecursiveOpClass *) klass)->handle_file = (void (*) (DejaDupRecursiveOp*)) deja_dup_recursive_move_real_handle_file;
	((DejaDupRecursiveOpClass *) klass)->handle_dir = (void (*) (DejaDupRecursiveOp*)) deja_dup_recursive_move_real_handle_dir;
	((DejaDupRecursiveOpClass *) klass)->finish_dir = (void (*) (DejaDupRecursiveOp*)) deja_dup_recursive_move_real_finish_dir;
	((DejaDupRecursiveOpClass *) klass)->clone_for_info = (DejaDupRecursiveOp* (*) (DejaDupRecursiveOp*, GFileInfo*)) deja_dup_recursive_move_real_clone_for_info;
}

static void
deja_dup_recursive_move_instance_init (DejaDupRecursiveMove * self,
                                       gpointer klass)
{
}

/**
 * Recursively moves one directory into another, merging files.  And by merge,
 * I mean it overwrites.  It skips any files it can't move and reports an
 * error, but keeps going.
 *
 * This is not optimized for remote files.  It's mostly async, but it does the
 * occasional sync operation.
 */
 G_GNUC_NO_INLINE static GType
deja_dup_recursive_move_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DejaDupRecursiveMoveClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) deja_dup_recursive_move_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DejaDupRecursiveMove), 0, (GInstanceInitFunc) deja_dup_recursive_move_instance_init, NULL };
	GType deja_dup_recursive_move_type_id;
	deja_dup_recursive_move_type_id = g_type_register_static (DEJA_DUP_TYPE_RECURSIVE_OP, "DejaDupRecursiveMove", &g_define_type_info, 0);
	return deja_dup_recursive_move_type_id;
}

GType
deja_dup_recursive_move_get_type (void)
{
	static volatile gsize deja_dup_recursive_move_type_id__volatile = 0;
	if (g_once_init_enter (&deja_dup_recursive_move_type_id__volatile)) {
		GType deja_dup_recursive_move_type_id;
		deja_dup_recursive_move_type_id = deja_dup_recursive_move_get_type_once ();
		g_once_init_leave (&deja_dup_recursive_move_type_id__volatile, deja_dup_recursive_move_type_id);
	}
	return deja_dup_recursive_move_type_id__volatile;
}

